#ifndef _KILIB_STRING_H_
#define _KILIB_STRING_H_
#include "types.h"
#include "memory.h"
#ifndef __ccdoc__
namespace ki {
#endif



//=========================================================================
//@{ @pkg ki.StdLib //@}
//@{
//	񏈗
//
//	ȂMFCCStringpNĂ܂BƂ肠 operator= ɂ
//	Pɂ͂قƂǃRXgȂ悤ɂ܂BSubStr()
//	Rs[Ȃ悤ɂ悤ƂvłA܂ł
//	vȂ낤ƂĈŁcB
//@}
//=========================================================================

class String : public Object
{
public:

	//@{ 󕶎쐬 //@}
	String();
	~String();

	//@{ ʂString̃Rs[ //@}
	String( const String& obj );

	//@{ ʂ̕z̃Rs[ //@}
	String( const TCHAR* str, long siz=-1 );

	//@{ \[X쐬 //@}
	explicit String( UINT rsrcID );

	//@{ 啶ʂr //@}
	bool operator==( LPCTSTR s ) const;
	bool operator==( const String& obj ) const;

	//@{ 啶ʂȂr //@}
	bool isSame( LPCTSTR s ) const;
	bool isSame( const String& obj ) const;

	//@{ P //@}
	String& operator=( const String& obj );
	String& operator=( const TCHAR* s );

	//@{ Z //@}
	String& operator+=( const String& obj );
	String& operator+=( const TCHAR* s );
	String& operator+=( TCHAR c );

	//@{ \[X[h //@}
	String& Load( UINT rsrcID );

	//@{ E //@}
	void TrimRight( ulong siz );

public:

	//@{ obt@Ԃ //@}
	const TCHAR* c_str() const;

	//@{  //@}
	ulong len() const;

public:

	//@{ ̈ꕶ //@}
	static TCHAR*       next( TCHAR* p );
	static const TCHAR* next( const TCHAR* p );

	//@{ QoCg̐擪ǂH //@}
	static bool isLB( TCHAR c );

protected:

	// ݉\ȃobt@AI[܂߂čŒłminimumpӂ
	TCHAR* AllocMem( ulong minimum );

	// ݏIAĐݒ
	void UnlockMem( long siz=-1 );

private:

	struct StringData
	{
		long  ref;         // QƃJE^
		ulong len;         // I['\0'܂߂钷
		ulong alen;        // 蓖ĂĂ郁̃TCY
		TCHAR* buf() const // TCHAR buf[alen]
			{ return reinterpret_cast<TCHAR*>(
				const_cast<StringData*>(this+1)
			); }
	};

private:

	TCHAR*  AllocMemHelper( ulong minimum, const TCHAR* str, ulong siz );
	TCHAR*  ReallocMem( ulong minimum );
	String& CatString( const TCHAR* str, ulong siz );
	String& SetString( const TCHAR* str, ulong siz );
	void    SetData( StringData* d );
	void    ReleaseData();
	static  StringData* null();
	        StringData* data() const;

private:

	StringData*        data_;
	static StringData* nullData_;
	static char        lb_[256];

private:

	static void LibInit();
	friend void APIENTRY Startup();
};



//-------------------------------------------------------------------------
#ifndef __ccdoc__

// 
inline String::String()
	{ SetData( null() ); }
// 
inline String::String( UINT rsrcID )
	{ SetData( null() ), Load( rsrcID ); }
// 
inline String::String( const String& obj )
	{ SetData( obj.data() ); }

// |C^vZT|[g
#ifdef _MBCS
	inline TCHAR* String::next( TCHAR* p )
		{ return p + lb_[*(uchar*)p]; }
	inline const TCHAR* String::next( const TCHAR* p )
		{ return p + lb_[*(const uchar*)p]; }
	inline bool String::isLB( TCHAR c )
		{ return lb_[(uchar)c]==2; }
#else // _UNICODE or _SBCS
	inline TCHAR* String::next( TCHAR* p )
		{ return p + 1; }
	inline const TCHAR* String::next( const TCHAR* p )
		{ return p + 1; }
	inline bool String::isLB( TCHAR c )
		{ return false; }
#endif

// m
inline TCHAR* String::AllocMem( ulong minimum )
	{ return AllocMemHelper( minimum, TEXT(""), 1 ); }
// Œ
inline void String::UnlockMem( long siz )
	{ data_->len = 1 + (siz==-1 ? ::lstrlen(c_str()) : siz); }

// Of[^
inline String::StringData* String::null()
	{ return nullData_; }
// f[^\
inline String::StringData* String::data() const
	{ return data_; }
// 
inline void String::SetData( String::StringData* d )
	{ data_=d, data_->ref++; }

// 
inline const TCHAR* String::c_str() const
	{ return data_->buf(); }
// 
inline ulong String::len() const
	{ return data_->len-1; }

// r
inline bool String::operator==( LPCTSTR s ) const
	{ return 0==::lstrcmp( c_str(), s ); }
// r
inline bool String::operator==( const String& obj ) const
	{ return (data_==obj.data_ ? true : operator==( obj.c_str() )); }
// r
inline bool String::isSame( LPCTSTR s ) const
	{ return 0==::lstrcmpi( c_str(), s ); }
// r
inline bool String::isSame( const String& obj ) const
	{ return (data_==obj.data_ ? true : operator==( obj.c_str() )); }

// vRs[
inline String& String::operator = ( const TCHAR* s )
	{ return SetString( s, ::lstrlen(s) ); }
// 
inline String& String::operator += ( const String& obj )
	{ return CatString( obj.c_str(), obj.len() ); }
// 
inline String& String::operator += ( const TCHAR* s )
	{ return CatString( s, ::lstrlen(s) ); }
// 
inline String& String::operator += ( TCHAR c )
	{ return CatString( &c, 1 ); }

//@{ String + String //@}
inline const String operator+( const String& a, const String& b )
	{ return String(a) += b; }
//@{ String + TCHAR* //@}
inline const String operator+( const String& a, const TCHAR* b )
	{ return String(a) += b; }
//@{ TCHAR* + String //@}
inline const String operator+( const TCHAR* a, const String& b )
	{ return String(a) += b; }



//=========================================================================

#endif // __ccdoc__
}      // namespace ki
#endif // _KILIB_STRING_H_
